unit U_Client;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          VirtualDBTreeEx GPL                       }
{           Source Language:  Francais, English                         }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2008 to 2016 (LAZARUS),             }
{    Copyright Microcelt 2006,                                          }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  AdvListV, RbSplitter, UltimDBGrid, RXSplit, JvXpButton, JvDateTimePicker,
  JvDBDateTimePicker, JvDBLookup, JvExComCtrls, JvExControls, JvComponent, Mask,
{$ELSE}
  MaskEdit,
{$ENDIF}
  LCLType, Messages, Graphics, Controls, Classes, ExtCtrls,  Dialogs, DB, IBQuery,IBTable,IBUpdateSQL,
  U_ExtDBNavigator, Buttons, Forms, DBCtrls, Grids, u_buttons_appli,
  DBGrids, u_framework_dbcomponents, ComCtrls, StdCtrls, SysUtils,
  TypInfo, Variants, StrUtils, ToolEdit, U_FormDico, 
  U_FormMainIni, ExtJvXPButtons,
  U_ExtDBGrid,U_ConstMessage,fonctions_string,
  U_OnFormInfoIni, u_framework_components,
  U_GroupView, ImgList;

const CST_INTE__CLIE = 'INTE__CLIE' ;
      CST_INTE_Clep  = 'INTE_Clep' ;
      CST_INTE_Fonction = 'INTE_Fonction' ;
      CST_AFFE_Clep  = 'AFFE_Clep' ;
      CST_AFFE_Libelle = 'AFFE_Libelle' ;
      CST_CLIE_Clep  = 'CLIE_Clep' ;
      CST_CLIE__REPR  = 'CLIE__REPR' ;
      CST_CLIE__FAMI  = 'CLIE__FAMI' ;
type

  { TF_Client }

  TF_Client = class(TF_FormDico)
    nv_navigator: TExtDBNavigator;
    lb_code: TFWLabel;
    ed_code: TFWDBEdit;
    pa_1: TPanel;
    pa_2: TPanel;
    pa_3: TPanel;
    pa_4: TPanel;
    pa_5: TPanel;
    pa_6: TPanel;
    lb_prenom: TFWLabel;
    ed_prenom: TFWDBEdit;
    chx_cliepro: TDBCheckBox;
    lb_cliepro: TFWLabel;
    nv_saisie: TExtDBNavigator;
    Rb_1: TSplitter;
    lb_datecrea: TFWLabel;
    gd_client: TExtDBGrid;
    lb_datecreation: TDBText;
    U_ExtDBNavigator1: TExtDBNavigator;
    SvgFormInfoIni: TOnFormInfoIni;
    ed_Nom: TFWDBEdit;
    lb_nom: TFWLabel;
    Panel9: TPanel;
    Panel20: TPanel;
    bt_apercu: TFWPreview;
    Panel21: TPanel;
    bt_imprimer: TFWPrint;
    Panel22: TPanel;
    Panel23: TPanel;
    bt_fermer: TFWClose;
    RbSplitter5: TSplitter;
    im_images: TImageList;
    lb_repr: TFWLabel;
    cbx_repr: TFWDBLookupCombo;
    procedure Bt_FermerClick(Sender: TObject);
    procedure F_FormDicoCreate(Sender: TObject);
    procedure F_FormDicoActivate(Sender: TObject);
    procedure gd_clientDblClick(Sender: TObject);
    procedure F_FormDicoDestroy(Sender: TObject);
    procedure F_FormDicoDataOnSave(Sender: TObject);
    procedure F_FormDicoDataOnCancel(Sender: TObject);
    procedure bt_apercuClick(Sender: TObject);
    procedure bt_imprimerClick(Sender: TObject);
    procedure F_FormDicoDataDBSourcescroll(DataSet: TDataSet);
    procedure F_FormDicoClose(Sender: TObject; var Action: TCloseAction);
    procedure gd_InterloDblClick(Sender: TObject);
    procedure ed_FonctionInterKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gd_AffecteDblClick(Sender: TObject);
    procedure ed_NomZoneKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure F_FormDicoDataOnLocate(DataSet: TDataSet);
    procedure p_AjouteBoutonsInserEdition ( const anv_Navigateur : TExtDBNavigator );
    procedure gd_clientGetCellProps(Sender: TObject; Field: TField;
      AFont: TFont; var Background: TColor);

  private
    { Déclarations privées }
    ts_Changing : TTabSheet ;
    // Inutile
    //function  LireCode     : string;
   //  procedure EcrireCodeclient(as_Code: string);
    procedure EcrireCodeAffe(as_Code: string);

    function LireCodeAffe: string;

  public
    { Déclarations publiques }
    gb_imprimer ,
    gb_DefocusCodePostaux,
    gb_AppelleInter,
    lb_PeutModifier  ,
    gb_AppelleAffecte,
    gb_DesactiveLocate,
    gb_valide : boolean;
//    li_TagVille : integer;
//    li_Tagcodpos : integer;
    procedure p_ApresInsert ;
    procedure Loaded; override;
    /// propriétés Inutiles
    property CodeAffeALire: string read LireCodeAffe write EcrireCodeAffe;
  end;

var
  gs_codeclient : String ;
  gb_appelClientDuDevis : Boolean = False ;
  F_Client: TF_Client;

implementation

uses U_CodePostal, U_DmDonn,
     fonctions_forms,
     fonctions_erreurs,
     u_extcomponent;
{$IFNDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}
var   gs_CodeAffe ,gs_codeInte, gs_adresse1,gs_adresse2,gs_adresse3,
      gs_cp,gs_ville,gs_tel,gs_raison : string;

///////////////////////////////////////////////////////////////////////
// Evènement : bt_FermerClick
// Description : Sur click bouton fermer on ferme
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.Bt_FermerClick(Sender: TObject);
begin
  Close;
end;

///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoCreate
// Description : Initialisation de la fiche
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoCreate(Sender: TObject);
begin
  nv_navigator.VisibleButtons := nv_navigator.VisibleButtons - [  ( nbERefresh )];
  lb_PeutModifier := true;
  gb_AppelleInter := False ;
  gb_AppelleAffecte := False ;
  gb_DesactiveLocate := False ;
  gb_imprimer := False ;

  F_Client := self;
//  M_Donn.zq_RechDevi.Active := True;
  M_Donn.ds_Civilite.Dataset.open ;

  // Pour la recherche
//  li_TagVille     := 11 ;
//  li_Tagcodpos    := 10 ;

end;

///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoActivate
// Description : Localisations inutiles
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoActivate(Sender: TObject);
begin
 if Showing then
  Begin
    // Positionnement direct sur la ligne si le code client est renseigné
   if not fb_stringVide(gs_codeclient) then
     Begin
       M_Donn.zq_client.Locate(CST_CLIE_Clep, gs_codeclient, [loPartialKey]);
       gs_codeclient := '' ;
     End ;
  End ;
  if not fb_stringVide(gs_codeInte) then
    M_Donn.zq_ClieInter.Locate('INTE_Clep', gs_codeInte, [loPartialKey]);
  if not fb_stringVide(gs_CodeAffe) then
    M_Donn.zq_ClieAffecte.Locate('AFFE_Clep', gs_CodeAffe, [loPartialKey]);
end;

///////////////////////////////////////////////////////////////////////
// Affectation de propriété : LireCodeAffe
// Description : Propriété inutile
///////////////////////////////////////////////////////////////////////
procedure TF_Client.EcrireCodeAffe(as_Code: string);
begin
  gs_CodeAffe := as_Code;
end;

///////////////////////////////////////////////////////////////////////
// Evènement : gd_clientDblClick
// Description : Sur double click grille client validation du client en mode modal
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.gd_clientDblClick(Sender: TObject);
begin
  if gb_AppelleInter
  or gb_AppelleAffecte then
    Exit ;
  if Self.FormStyle = fsNormal then
    begin
      gb_valide     := true;
      gs_codeclient := ed_code.Text;
      gs_raison     := ed_nom.text;
      Close;
    end;
end;


///////////////////////////////////////////////////////////////////////
// Lecture de propriété : LireCodeAffe
// Description : Propriété inutile
///////////////////////////////////////////////////////////////////////
function TF_Client.LireCodeAffe: string;
begin
  result := gs_codeAffe;
end;

///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoDestroy
// Description : Destruction des variables objets et mise à nil des pointeurs globaux
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoDestroy(Sender: TObject);
begin
  F_Client := nil ;
end;


///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoDataOnSave
// Description : Accès à une partie des données à l'édition des données
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoDataOnSave(Sender: TObject);
begin
  if not(gd_client.Datasource.DataSet.State in [dsInsert,dsEdit]) then
    begin
      gd_client.Enabled := FALSE;
      nv_navigator.Enabled := FALSE;
      nv_saisie.Enabled := FALSE;
      pa_6.Enabled := FALSE;
    end;

end;

///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoDataOnCancel
// Description : Accès à toutes les données après le cancel ou après le post
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoDataOnCancel(Sender: TObject);
begin
  gd_client.Enabled := True ;
  nv_navigator.Enabled := True ;
  nv_saisie.Enabled := True ;
  pa_6.Enabled := True ;

end;

///////////////////////////////////////////////////////////////////////
// Evènement : bt_apercuClick
// Description : Sur aperçu ouverture crystal reports
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.bt_apercuClick(Sender: TObject);
var ts_param, ts_param_valeur : TStringList;
Begin
  try

    ts_param := TStringList.create();
    ts_param_valeur  := TStringList.create();
    ts_param.Add('num_client');
    ts_param_valeur.Add ( ed_code.Text );

  finally
  end;


end;

///////////////////////////////////////////////////////////////////////
// Evènement : bt_imprimerClick
// Description : Sur impression mode aperçu prêt à imprimer
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.bt_imprimerClick(Sender: TObject);
begin
  gb_imprimer := True ;
  bt_apercuClick(Sender);
end;

///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoDataDBSourcescroll
// Description : Sur scroll mises à jour correcte des données
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoDataDBSourcescroll(DataSet: TDataSet);
var li_i : Integer ;
begin

  try

    if gd_client.Datasource.DataSet.IsEmpty Then
      Begin
        if M_Donn.zq_ClieInter.Params.FindParam ( 'Client' ).Value <> Null Then
          Begin
            M_Donn.zq_ClieInter.Close ;
            M_Donn.zq_ClieInter.Params.FindParam ( 'Client' ).Value := Null ;
            M_Donn.zq_ClieInter.Open ;
          End ;
      End
    Else
      Begin
        M_Donn.zq_ClieInter.Close ;
        M_Donn.zq_ClieInter.Params.FindParam ( 'Client' ).Value := gd_client.Datasource.DataSet.FieldByName (  CST_CLIE_Clep ).Value ;
        M_Donn.zq_ClieInter.Open ;
      End ;

    if gd_client.Datasource.DataSet.IsEmpty Then
      Begin
        if M_Donn.zq_CliDevis.Params.FindParam ( 'Client' ).Value <> Null Then
          Begin
            M_Donn.zq_CliDevis.Close ;
            M_Donn.zq_CliDevis.Params.FindParam ( 'Client' ).Value := Null ;
            M_Donn.zq_CliDevis.Open ;
          End ;
      End
    Else
      Begin
        M_Donn.zq_CliDevis.Close ;
        M_Donn.zq_CliDevis.Params.FindParam ( 'Client' ).Value := gd_client.Datasource.DataSet.FieldByName (  CST_CLIE_Clep ).Value ;
        M_Donn.zq_CliDevis.Open ;
      End ;
    M_Donn.zq_CliCmde.Close ;
    if gd_client.Datasource.DataSet.IsEmpty Then
      Begin
        M_Donn.zq_CliCmde.Params.FindParam ( 'Client' ).Value := Null
      End
    Else
      Begin
        M_Donn.zq_CliCmde.Params.FindParam ( 'Client' ).Value := gd_client.Datasource.DataSet.FieldByName (  CST_CLIE_Clep ).Value ;
      End ;
    M_Donn.zq_CliCmde.Open ;
  Except
    on e: Exception do
      f_GereException ( e, gd_client.Datasource.DataSet );
  End ;
end;

///////////////////////////////////////////////////////////////////////
// Evènement : F_FormDicoClose
// Description : Sur fermeture on ne fait que cacher la fiche
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoClose(Sender: TObject;
  var Action: TCloseAction);
begin
  // Préparation pour la recherche à le prochaine ouverture de fiche

  gd_client.Datasource.DataSet.Filter := '';
  Action := caHide ;
end;

///////////////////////////////////////////////////////////////////////
// Evènement : gd_InterloDblClick
// Description : Sur double click et appel mode interlocuteur validation de l'affectation
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.gd_InterloDblClick(Sender: TObject);
begin
  if not gb_AppelleInter then
    Exit ;
  if Self.FormStyle = fsNormal then
     begin
      gb_valide     := true;
      gs_codeInte   := M_Donn.ds_ClieInter.DataSet.FieldByName ( CST_INTE_Clep ).AsString ;
      Close;
    end;

end;

///////////////////////////////////////////////////////////////////////
// Evènement : ed_FonctionInterKeyUp
// Description : Sur touche relevée ajout du texte de l'interlocuteur déjà enregistré
// Arguments : Sender : TObject
//             Key    : la touche relevée
//             Shift  : Touches spéciales
///////////////////////////////////////////////////////////////////////
procedure TF_Client.ed_FonctionInterKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var li_Pos : Integer ;
begin
  if Key in [ VK_RETURN, VK_TAB, VK_DELETE, VK_BACK ] Then
    Exit ;
  M_Donn.zq_InteFonct.Open ;
end;

///////////////////////////////////////////////////////////////////////
// Evènement : gd_AffecteDblClick
// Description : Sur double click et appel mode affectation validation de l'affectation
// Arguments : Sender : TObject
///////////////////////////////////////////////////////////////////////
procedure TF_Client.gd_AffecteDblClick(Sender: TObject);
begin
  if not gb_AppelleAffecte then
    Exit ;
  if Self.FormStyle = fsNormal then
    begin
      gb_valide     := true;
      gs_CodeAffe   := M_Donn.ds_ClieAffecte.DataSet.FieldByName ( CST_AFFE_Clep ).AsString ;
      Close;
    end;

end;

///////////////////////////////////////////////////////////////////////
// Evènement : ed_NomZoneKeyUp
// Description : Sur touche relevée ajout du texte déjà enregistré
// Arguments : Sender : TObject
//             Key    : la touche relevée
//             Shift  : Touches spéciales
///////////////////////////////////////////////////////////////////////
procedure TF_Client.ed_NomZoneKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var li_Pos : Integer ;
begin
  if Key in [ VK_RETURN, VK_TAB, VK_DELETE, VK_BACK ] Then
    Exit ;
  M_Donn.zq_AffeZone.Open ;

end;

///////////////////////////////////////////////////////////////////////
// Procedure : F_FormDicoDataOnLocate
// Description : permet de positionner sur le premier enregitrement en fonction de la saisie
//     du code postal ou de la ville
// Arguments : DataSet: TDataSet
///////////////////////////////////////////////////////////////////////
procedure TF_Client.F_FormDicoDataOnLocate(DataSet: TDataSet);
begin

  if ( Dataset = M_Donn.ds_Ville.DataSet)
    or ( Dataset = M_Donn.ds_filtreville.DataSet)
    or ( Dataset = M_Donn.ds_filtrecp.DataSet)       Then
    Begin
        // mise à jour du code postal, ville et code insee sur la fiche client
        if not gb_DesactiveLocate Then
          Begin
            if not (M_Donn.zq_client.state in [dsInsert, dsEdit]) Then M_Donn.zq_client.Edit;
            M_Donn.zq_client.FieldByName('CLIE_Codepostal').Value := DataSet.FieldByName('COPO_Clep').AsString;
            M_Donn.zq_client.FieldByName('CLIE_Ville').Value := DataSet.FieldByName ('COPO_Ville').AsString;
            M_Donn.zq_client.FieldByName('CLIE_Codeinsee').Value := DataSet.FieldByName ('COPO_Codinsee').AsString;
          End ;



   end;



end;


/////////////////////////////////////////////////////////////////////////////
// Procédure : p_AjouteBoutonsInserEdition
// Description : Affiche les boutons d'insertion/suppression et d'édition
/////////////////////////////////////////////////////////////////////////////
procedure TF_Client.p_AjouteBoutonsInserEdition(
  const anv_Navigateur: TExtDBNavigator);
Begin
  anv_Navigateur.VisibleButtons := anv_Navigateur.VisibleButtons + [  ( nbEPost ),  ( nbECancel ),  ( nbEInsert ),  ( nbEDelete ) ];
End ;

/////////////////////////////////////////////////////////////////////////////
// Procédure : p_ApresInsert
// Description : Filtrages et visualisation des données de gd_client.Datasource principal à l'insertion
/////////////////////////////////////////////////////////////////////////////
procedure TF_Client.p_ApresInsert;
Begin

  F_FormDicoDataDBSourcescroll ( M_Donn.zq_client  );
End ;

procedure TF_Client.Loaded;
begin
  
  with DBSources.Add do
    Begin
      Table:='CLIENT';
      Grid := gd_client;
      NavEdit:=nv_saisie;
      Navigator:=nv_navigator;
      Panels.Add.Panel:=pa_6;
    end;
  inherited;
end;


procedure TF_Client.gd_clientGetCellProps(Sender: TObject; Field: TField;
  AFont: TFont; var Background: TColor);
begin
  if not gb_appelClientDuDevis then
    if Field.FieldName = 'CLIE_Ville' then
      gd_client.Columns.Items[3].Width := 0;
end;

end.


