unit U_DmArticle;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          VirtualDBTreeEx GPL                       }
{           Source Language:  Francais, English                         }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2008 to 2016 (LAZARUS),             }
{    Copyright Microcelt 2006,                                          }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  SysUtils,StrUtils, Classes, DB, IBQuery,IBTable,IBUpdateSQL,
  Forms,Dialogs,controls,fonctions_string, U_FormDico, U_ConstMessage,
  U_DmDonn;
type

  { TM_Article }

  TM_Article = class(TDataModule)
    ds_article: TDataSource;
    zq_artcoul: TIBQuery;
    ds_ARCO: TDataSource;
    ds_ArFini: TDataSource;
    zq_CocoCoul: TIBQuery;
    ds_CocoCoul: TDataSource;
    ds_FiltreProduit: TDataSource;
    zq_FiltreProduit: TIBQuery;
    zq_Article1: TIBQuery;
    zq_prod_acces: TIBQuery;
    ds_prod_acces: TDataSource;
    ds_ArbreArt: TDataSource;
    zq_ArbreArt: TIBQuery;
    zq_code_copieart: TIBQuery;
    zq_copieart: TIBQuery;
    zq_ArFini: TIBQuery;
    procedure DataModuleCreate(Sender: TObject);
    procedure zq_articleAfterScroll(DataSet: TDataSet);
    procedure zq_articleNewRecord(DataSet: TDataSet);
    procedure zq_articleAfterOpen(DataSet: TDataSet);
    procedure zq_AffectePostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure zq_FinitionAfterOpen(DataSet: TDataSet);
    procedure zq_Article1NewRecord(DataSet: TDataSet);
    procedure zq_Article1AfterInsert(DataSet: TDataSet);
    procedure zq_ArbreArtAfterOpen(DataSet: TDataSet);
    procedure zq_artcoulAfterCancel(DataSet: TDataSet);
    procedure zq_ArFiniNewRecord(DataSet: TDataSet);
  end;

var
  M_Article: TM_Article;

implementation

uses U_Client, U_Composant,
     U_SeleArticle, U_ComposeArticle, Variants , fonctions_dbcomponents,
  U_CodePostal, U_Representant ,U_Modalite,
  U_DmCompose;

{$IFNDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}
procedure TM_Article.zq_articleAfterScroll(DataSet: TDataSet);
begin
 { with  zq_artfinition do
  begin
      Active := false;
      Params.ParamByName('art').Value := ds_article.DataSet.FieldByName('ARTI_Clep').asString;
      Open;
  end; }
{  if assigned ( F_SeleArticle )
  and F_SeleArticle.Visible Then
    F_SeleArticle.lb_datecreation.Caption := FormatDateTime('d/mm/yyyy',M_Article.zq_Article.FieldByName('ARTI_Datecrea').AsDateTime);}

  TDateField(M_Article.ds_article.DataSet.FieldByName('ARTI_Datecrea')).DisplayFormat := U_CST_format_date_2;    
end;

procedure TM_Article.DataModuleCreate(Sender: TObject);
begin
   p_SetConnection ( Self, M_Donn.IBConnect );
end;


procedure TM_Article.zq_articleNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('ARTI_Datecrea').AsDateTime := now;
  DataSet.FieldByName('ARTI_Compose').AsBoolean  := False;
end;


procedure TM_Article.zq_articleAfterOpen(DataSet: TDataSet);
begin
  TDateTimeField (DataSet.FieldByName( 'ARTI_Datecrea' )).DisplayFormat := U_CST_format_date_2 ;
  TNumericField  (DataSet.FieldByName( 'ARTI_Pxactu'   )).DisplayFormat := U_CST_format_money_1 ;
  TNumericField  (DataSet.FieldByName( 'ARTI_Pxfutur'  )).DisplayFormat := U_CST_format_money_1 ;
  TNumericField  (DataSet.FieldByName( 'ARTI_Cubage'   )).DisplayFormat := U_CST_format_money_1 ;
  TNumericField  (DataSet.FieldByName( 'ARTI_Coefcub'  )).DisplayFormat := U_CST_format_money_1 ;
  TNumericField  (DataSet.FieldByName( 'ARTI_Poids'    )).DisplayFormat := U_CST_format_money_1 ;
end;

procedure TM_Article.zq_AffectePostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  MessageDlg ( 'La zone ''Nom de la zone'' ne peut pas ?tre vide.' + #13 + #13
                           + 'Effectuer une saisie ou annuler.', mtWarning, [mbOk], 0)
end;

procedure TM_Article.zq_FinitionAfterOpen(DataSet: TDataSet);
begin
  TNumericField ( Dataset.FieldByName ( 'FINI_Txcharge' )).DisplayFormat := U_CST_format_money_1 ;
end;

//*****************************
// Proc?dure: zq_paysAfterPost
// Mise ? jour affichage des clients associ?s au pays
//**************************
procedure TM_Article.zq_Article1NewRecord(DataSet: TDataSet);
begin
  Dataset.FieldByName ( CST_ARTI_Date ).Value := FormatDateTime(U_CST_format_date_2,Now) ;
end;



procedure TM_Article.zq_Article1AfterInsert(DataSet: TDataSet);
begin
  DataSet.FieldByName ( 'ARTI_Declasse' ).Value := 0;
  DataSet.FieldByName ( 'ARTI_Compose'  ).Value := 0;

end;

procedure TM_Article.zq_ArbreArtAfterOpen(DataSet: TDataSet);
begin
  TNumericField(zq_ArbreArt.FieldByName('ARDE_Prix')).DisplayFormat := U_CST_format_money_1 ;
end;

///////////////////////////////////////////////////////////////////////
// Procedure : zq_ArticleBeforeEdit
// Description : controle du profil, car une assitante ne peut modifier
//    que les articles speciaux (donc pas de creation ni suppr ni modif
//    de l'article ou de ses finitions)
///////////////////////////////////////////////////////////////////////
procedure TM_Article.zq_artcoulAfterCancel(DataSet: TDataSet);
begin
   M_DmCompose.p_FiltreCouleur ( zq_ArFini, DataSet.FieldByName ( CST_ARFI__FINI ));

end;


procedure TM_Article.zq_ArFiniNewRecord(DataSet: TDataSet);
begin
  Dataset.FieldByName ( CST_ARFI_Choixfinit ).Value := 4 ;

end;

end.
